Unit AV14C_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, UTAV10_p;

procedure AV14C(N :Integer; var SX :Array of Complex; INCX :Integer;
                var SY :Array of Complex; INCY :Integer;
                var IERR :Integer);

implementation

procedure AV14C(N :Integer; var SX :Array of Complex; INCX :Integer;
                var SY :Array of Complex; INCY :Integer;
                var IERR :Integer);
var
I,IX,IY,M,MP1 :Integer;
STEMP :Complex;
label
_10,_20,_30,_40,_50,_60,_70;
begin
if ( N  <=  0 ) 
 then goto _60;
IERR  := 0;
if ( INCX  =  1 ) and (  INCY  =  1 ) 
 then goto _20;
IY  := 1 + ((INCY - Abs(INCY)) div 2)*(1 - N);
IX  := 1 + ((INCX - Abs(INCX)) div 2)*(1 - N);
for I:=1 to N do
 begin
  STEMP  := SX[IX-1];
  SX[IX-1] := SY[IY-1];
  SY[IY-1] := STEMP;
  IX  := IX + INCX;
  IY  := IY + INCY;
_10:
 end;
goto _70;
_20:
M  := ((N) Mod (3));
if ( M  =  0 ) 
 then goto _40;
for I:=1 to M do
 begin
  STEMP  := SX[I-1];
  SX[I-1] := SY[I-1];
  SY[I-1] := STEMP;
_30:
 end;
if ( N  <  3 ) 
 then goto _70;
_40:
MP1  := M + 1;
I := MP1;
while ( I<=N ) do
 begin
  STEMP  := SX[I-1];
  SX[I-1] := SY[I-1];
  SY[I-1] := STEMP;
  STEMP  := SX[I+0];
  SX[I+0] := SY[I+0];
  SY[I+0] := STEMP;
  STEMP  := SX[I+1];
  SX[I+1] := SY[I+1];
  SY[I+1] := STEMP;
_50:
  inc(I,3);
 end;
goto _70;
_60:
IERR  := 65;
UTAV10(IERR,15);
_70:
end;

end.
